#include "mv.hh"
#include "TimeMeter.hh"
#include <iostream>

using namespace std ;

#define TEST(MM) \
  tm.start() ; \
  for ( int i = 0 ; i < NLOOP ; ++i ) { \
    MM( A, B, C ) ; \
    MM( C, B, A ) ; \
    MM( A, B, C ) ; \
    MM( C, B, A ) ; \
    MM( A, B, C ) ; \
    MM( C, B, A ) ; \
    MM( A, B, C ) ; \
    MM( C, B, A ) ; \
    MM( A, B, C ) ; \
    MM( C, B, A ) ; \
  } \
  tm.stop() ; \
  cout << #MM << " time = " << tm.elapsed()/(10*NLOOP) << '\n'

#define TESTT(TS) \
  tm.start() ; \
  for ( int i = 0 ; i < NLOOP ; ++i ) { \
    Mat_x_Mat_with_tiling( A, B, C, TS ) ; \
    Mat_x_Mat_with_tiling( C, B, A, TS ) ; \
    Mat_x_Mat_with_tiling( A, B, C, TS ) ; \
    Mat_x_Mat_with_tiling( C, B, A, TS ) ; \
    Mat_x_Mat_with_tiling( A, B, C, TS ) ; \
    Mat_x_Mat_with_tiling( C, B, A, TS ) ; \
    Mat_x_Mat_with_tiling( A, B, C, TS ) ; \
    Mat_x_Mat_with_tiling( C, B, A, TS ) ; \
    Mat_x_Mat_with_tiling( A, B, C, TS ) ; \
    Mat_x_Mat_with_tiling( C, B, A, TS ) ; \
  } \
  tm.stop() ; \
  cout << "Mat_x_Mat_with_tiling(" << TS << ") time = " \
       << tm.elapsed()/(10*NLOOP) << '\n'

int
main() {
  int N = 500 ;

  struct Vec a(100), b(100), c(100) ;
  struct Mat A, B, C(N,N) ;
  
  TimeMeter tm ;

  A.AllocateAndInitializeRandom( N, N ) ;
  B.AllocateAndInitializeRandom( N, N ) ;
  
  int NLOOP = 2 ;

  tm.start() ;
  for ( int i = 0 ; i < NLOOP ; ++i ) {
    Mat_x_Mat_123( A, B, C ) ;
    Mat_x_Mat_123( C, B, A ) ;
    Mat_x_Mat_123( A, B, C ) ;
    Mat_x_Mat_123( C, B, A ) ;
    Mat_x_Mat_123( A, B, C ) ;
    Mat_x_Mat_123( C, B, A ) ;
    Mat_x_Mat_123( A, B, C ) ;
    Mat_x_Mat_123( C, B, A ) ;
    Mat_x_Mat_123( A, B, C ) ;
    Mat_x_Mat_123( C, B, A ) ;
  }
  tm.stop() ;
  cout << "Mat_x_Mat_123 time = " << tm.elapsed()/(10*NLOOP) << '\n' ;

  TEST(Mat_x_Mat_132) ;
  TEST(Mat_x_Mat_213) ;
  TEST(Mat_x_Mat_231) ;
  TEST(Mat_x_Mat_312) ;
  TEST(Mat_x_Mat_321) ;

  TESTT( 10 ) ;
  TESTT( 20 ) ;
  TESTT( 40 ) ;
  TESTT( 80 ) ;
  TESTT( 120 ) ;
  TESTT( 160 ) ;

}
